let quiz = {
// PROPERTIES
// QUESTIONS & ANSWERS
// Q = QUESTION, O = OPTIONS, A = CORRECT ANSWER
data: [
{
q: "Кто признан лучшим вратарём в 2019 году по версии ФИФА?",
o: [
"Давид де Хеа",
"Алиссон",
"Тибо Куртуа",
"Ян Облак",
],
a: 0
},
{
q: "Кто является лучшим бомбардиром за всю историю сборной Португалии?",
o: [
"Матийс де Лигт",
"Лионель Месси",
"Криштиану Роналду",
"Вирджил ван Дейк",
],
a: 2
},
{
q: "В какой стране впервые проходил Кубок мира ФИФА?",
o: [
"Уругвай",
"Франция",
"Испания",
"Англия",
],
a: 0
},
{
q: "Как называется гол, который футболист забил в свои ворота?",
o: [
"Штрафной",
"«Мертвый мяч»",
"Автогол",
"Ложный маневр",
],
a: 2
},
{
q: "Какое количество игроков одновременно находится на игровом поле с двух сторон?",
o: [
"30 игроков",
"24 игрока",
"11 игроков",
"22 игрока",
],
a: 3
}
  ],
// HTML ELEMENTS
hWrap: null, // HTML quiz container
hQn: null, // HTML question wrapper
hAns: null, // HTML answers wrapper
// GAME FLAGS
now: 0, // current question
score: 0, // current score
// INIT QUIZ HTML
init: () => {
// WRAPPER
quiz.hWrap = document.getElementById("quizWrap");
// QUESTIONS SECTION
quiz.hQn = document.createElement("div");
quiz.hQn.id = "quizQn";
quiz.hWrap.appendChild(quiz.hQn);
// ANSWERS SECTION
quiz.hAns = document.createElement("div");
quiz.hAns.id = "quizAns";
quiz.hWrap.appendChild(quiz.hAns);
// GO!
quiz.draw();
},
// DRAW QUESTION
draw: () => {
// QUESTION
quiz.hQn.innerHTML = quiz.data[quiz.now].q;
// OPTIONS
quiz.hAns.innerHTML = "";
for (let i in quiz.data[quiz.now].o) {
let radio = document.createElement("input");
radio.type = "radio";
radio.name = "quiz";
radio.id = "quizo" + i;
quiz.hAns.appendChild(radio);
let label = document.createElement("label");
label.innerHTML = quiz.data[quiz.now].o[i];
label.setAttribute("for", "quizo" + i);
label.dataset.idx = i;
label.addEventListener("click", () => {
quiz.select(label);
});
quiz.hAns.appendChild(label);
}
},
// OPTION SELECTED
select: (option) => {
//  DETACH ALL ONCLICK
let all = quiz.hAns.getElementsByTagName("label");
for (let label of all) {
label.removeEventListener("click", quiz.select);
}
// CHECK IF CORRECT
let correct = option.dataset.idx == quiz.data[quiz.now].a;
if (correct) {
quiz.score++;
option.classList.add("correct");
} else {
option.classList.add("wrong");
}
// NEXT QUESTION OR END GAME
quiz.now++;
setTimeout(() => {
if (quiz.now < quiz.data.length) { quiz.draw(); }
else {
quiz.hQn.innerHTML = `Вы ответили на ${quiz.score} из ${quiz.data.length} правильно.`;
quiz.hAns.innerHTML = "";
}
}, 1000);
},
// RESTART QUIZ
reset : () => {
quiz.now = 0;
quiz.score = 0;
quiz.draw();
}
};
window.addEventListener("load", quiz.init);